SystemOrganization addCategory: #'SqSync-Shared'!
SystemOrganization addCategory: #'SqSync-Client'!
SystemOrganization addCategory: #'SqSync-Server'!
SystemOrganization addCategory: #'SqSync-Tests'!

SocketStream subclass: #SyTcpSocket
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSync-Shared'!

!SyTcpSocket class methodsFor: 'instance creation' stamp: 'mt 5/10/2010 11:05:32.461'!
connectToHost: nameOrAddressString port: anInteger
	
	^ self
		openConnectionToHostNamed: nameOrAddressString
		port: anInteger! !

!SyTcpSocket methodsFor: 'testing' stamp: 'mt 5/31/2010 12:13:09.093'!
isConnected
	"Fix socket bug under windows. Trigger a new receive operation to force status update in the plugin."
		
	self adjustInBuffer: (self socket
		receiveDataNonBlockingInto: inBuffer
		startingAt: inNextToWrite).
	
	^ self socket isConnected! !

!SyTcpSocket methodsFor: 'stream out' stamp: 'mt 5/30/2010 20:51:40.078'!
nextPutAll: aCollection
	"Overridden to be better testable with a normal stream. Use the optimized version #nextPutAllFlush:."
	
	^ self nextPutAllFlush: aCollection.! !

!SyTcpSocket methodsFor: 'accessing' stamp: 'mt 5/10/2010 11:23:48.023'!
remoteAddress

	^ self socket remoteAddress! !

!SyTcpSocket methodsFor: 'accessing' stamp: 'mt 5/30/2010 21:34:56.652'!
remoteAddressString

	^ NetNameResolver stringFromAddress: self socket remoteAddress! !

!SyTcpSocket methodsFor: 'accessing' stamp: 'mt 5/30/2010 21:36:39.6'!
remoteID

	^ self remoteAddressString, ':', self remotePort asString! !

!SyTcpSocket methodsFor: 'accessing' stamp: 'mt 5/10/2010 11:23:53.871'!
remotePort

	^ self socket remotePort! !

!SyTcpSocket methodsFor: 'waiting' stamp: 'mt 5/9/2010 17:23:15.848'!
waitForDataIfClosed: aBlock

	^ self socket waitForDataIfClosed: aBlock! !

!Socket methodsFor: '*SqSync' stamp: 'mt 5/31/2010 12:13:53.535'!
forceStatusUpdate
	"Workaround for broken Windows socket plugin. Better use SyTcpSocket where #isConnected will not loose any bytes if available."

	self
		receiveDataNonBlockingInto: ' '
		startingAt: 1.! !

!Socket methodsFor: '*SqSync' stamp: 'mt 5/31/2010 12:14:08.19'!
receiveDataNonBlockingInto: aStringOrByteArray startingAt: aNumber
	"To be used to fix the status bug under Windows."

	^ self primSocket: socketHandle
		receiveDataInto: aStringOrByteArray
		startingAt: aNumber
		count: aStringOrByteArray size - aNumber + 1! !

MwMethodWrapper subclass: #SyMethodWrapper
	instanceVariableNames: 'instrumentor'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSync-Shared'!

!SyMethodWrapper class methodsFor: 'as yet unclassified' stamp: 'SR 5/16/2010 17:18:44.185'!
on: aSymbol inClass: aClass for: anInstrumentor

	| wrapper |
	wrapper := self on: aSymbol inClass: aClass.
	wrapper instrumentor: anInstrumentor.
	^ wrapper! !

!SyMethodWrapper methodsFor: 'accessing' stamp: 'SR 5/16/2010 17:17:42.497'!
instrumentor

	^ instrumentor! !

!SyMethodWrapper methodsFor: 'accessing' stamp: 'SR 5/16/2010 17:17:39.016'!
instrumentor: anObject

	instrumentor := anObject! !

!SyMethodWrapper methodsFor: 'evaluating' stamp: 'SR 5/20/2010 18:24:23.891'!
valueWithReceiver: anObject arguments: anArrayOfObjects

	| result |
	result := self clientMethod valueWithReceiver: anObject arguments: anArrayOfObjects.
	(SyOperation shouldBeReplicated: (self selector)) ifTrue: [
		instrumentor ifNotNil: [
			instrumentor methodCalled: (self selector) on: anObject with: anArrayOfObjects resulting: result.
		].
	].
	^ result! !

Object subclass: #Person
	instanceVariableNames: 'givenName surname birthday address'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSync-Tests'!

!Person commentStamp: 'mt 5/19/2010 13:05:53.083' prior: 0!
I am part of the example domain model.!

!Person class methodsFor: 'as yet unclassified' stamp: 'SR 5/15/2010 12:28:45.274'!
givenName: aFirstString surname: aSecondString

	^ (self new)
		givenName: aFirstString;
		surname: aSecondString;
		yourself.! !

!Person methodsFor: 'comparing' stamp: 'SR 5/15/2010 15:24:16.133'!
= anObject 

	^ (self givenName = anObject givenName) and: [self surname = anObject surname] and: [self birthday = anObject birthday] and: [self address = anObject address]! !

!Person methodsFor: 'accessing' stamp: 'SR 5/15/2010 12:25:08.009'!
address
	^ address! !

!Person methodsFor: 'accessing' stamp: 'SR 5/15/2010 12:26:51.253'!
address: aString

	(aString isString) ifFalse: [Exception signal: 'Invalid data type'].
	address := aString! !

!Person methodsFor: 'accessing' stamp: 'SR 5/15/2010 12:25:18.253'!
birthday
	^ birthday! !

!Person methodsFor: 'accessing' stamp: 'SR 5/15/2010 12:27:34.621'!
birthday: aString

	(aString isString) ifFalse: [Exception signal: 'Invalid data type'].
	birthday := aString! !

!Person methodsFor: 'accessing' stamp: 'SR 5/15/2010 12:25:24.381'!
givenName
	^ givenName! !

!Person methodsFor: 'accessing' stamp: 'SR 5/15/2010 12:26:32.385'!
givenName: aString

	(aString isString) ifFalse: [Exception signal: 'Invalid data type'].
	givenName := aString! !

!Person methodsFor: 'accessing' stamp: 'SR 5/15/2010 12:25:32.002'!
surname
	^ surname! !

!Person methodsFor: 'accessing' stamp: 'SR 5/15/2010 12:26:22.555'!
surname: aString

	(aString isString) ifFalse: [Exception signal: 'Invalid data type'].
	surname := aString.! !

Object subclass: #SyClassInstrumentor
	instanceVariableNames: 'classes methods processor'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSync-Shared'!

!SyClassInstrumentor commentStamp: 'SR 5/20/2010 18:32:53.47' prior: 0!
Used to configure method wrappers:

| instr o1 |
instr := SyClassInstrumentor new.
o1 := Person new.

instr instrumentClass: (o1 class).
o1 givenName: 'test'.
instr uninstrumentAllAndReset.

If not correctly clean up, use: SyMethodWrapper allInstances do: [:mw|mw uninstall]!

!SyClassInstrumentor methodsFor: 'instrumenting' stamp: 'SR 5/16/2010 16:27:33.49'!
instrumentClass: aClass

	| metaClass |
	metaClass := aClass class.
	(self isClassInstrumented: aClass) ifFalse: [
		{aClass. metaClass} do: [:c |
			self instrumentedClasses add: c.
			c selectors do: [:selector | self instrumentMethod: selector inClass: c ]
		]
	].! !

!SyClassInstrumentor methodsFor: 'instrumenting' stamp: 'SR 5/16/2010 17:19:22.051'!
instrumentMethod: selector inClass: aClass

	| wrapper |
	(self isMethodInstrumented: selector inClass: aClass)  ifFalse: [
		SystemChangeNotifier uniqueInstance doSilently: [
			wrapper := SyMethodWrapper on: selector inClass: aClass for: self.
			wrapper install.
		].
		(self instrumentedMethodsAt: aClass) add: selector.
	].! !

!SyClassInstrumentor methodsFor: 'accessing' stamp: 'SR 5/16/2010 16:23:09.66'!
instrumentedClasses

	^ classes ifNil: [classes := WeakSet new]! !

!SyClassInstrumentor methodsFor: 'accessing' stamp: 'SR 5/16/2010 16:24:14.84'!
instrumentedMethods

	^ methods ifNil: [methods := WeakKeyDictionary new] ! !

!SyClassInstrumentor methodsFor: 'accessing' stamp: 'SR 5/16/2010 16:24:05.214'!
instrumentedMethodsAt: aClass

	^ self instrumentedMethods at: aClass ifAbsentPut: [Set new]! !

!SyClassInstrumentor methodsFor: 'testing' stamp: 'SR 5/16/2010 16:25:39.999'!
isClassInstrumented: aClass

	^ self instrumentedClasses includes: aClass! !

!SyClassInstrumentor methodsFor: 'testing' stamp: 'SR 5/16/2010 16:25:48.289'!
isMethodInstrumented: selector inClass: aClass

	^ (self instrumentedMethods at: aClass ifAbsent: [Array empty]) includes: selector! !

!SyClassInstrumentor methodsFor: 'instrumenting' stamp: 'SR 5/17/2010 19:49:01.808'!
methodCalled: aSelector on: anObject with: anArrayOfObjects resulting: result

	self processor ifNotNil: [ self processor process: aSelector on: anObject with: anArrayOfObjects ].! !

!SyClassInstrumentor methodsFor: 'accessing' stamp: 'SR 5/17/2010 19:48:49.324'!
processor
	^ processor! !

!SyClassInstrumentor methodsFor: 'accessing' stamp: 'SR 5/17/2010 19:48:49.336'!
processor: anObject
	processor := anObject! !

!SyClassInstrumentor methodsFor: 'instrumenting' stamp: 'SR 5/16/2010 16:36:25.493'!
uninstrumentAllAndReset

	self instrumentedClasses do: [:ea | 
		self uninstrumentClass: ea.
	].

	self instrumentedMethods keysAndValuesDo: [ :aClass :selectors | 
		selectors do: [:s | 
			self uninstrumentMethod: (aClass >> s).
		].
	].

	self instrumentedMethods keysAndValuesRemove: [:k :v | true ].! !

!SyClassInstrumentor methodsFor: 'instrumenting' stamp: 'SR 5/16/2010 16:37:17.823'!
uninstrumentClass: aClass

	| metaClass |
	metaClass := aClass class.
	(self isClassInstrumented: aClass) ifTrue: [
		self instrumentedClasses remove: aClass.
		self instrumentedClasses remove: metaClass ifAbsent: []
	].
	
	{aClass. metaClass} do: [:c |
		c methodDict values do: [:method | self uninstrumentMethod: method ]
	].! !

!SyClassInstrumentor methodsFor: 'instrumenting' stamp: 'SR 5/16/2010 17:20:18.101'!
uninstrumentMethod: aCompiledMethod

	| registeredMethods aClass selector |
	aClass := aCompiledMethod methodClass.
	selector := aCompiledMethod selector.

	(self isMethodInstrumented: selector inClass: aClass)  ifTrue: [
		aCompiledMethod isMwMethodWrapper ifTrue: [	
			aCompiledMethod uninstall.
		].
	
		registeredMethods := self instrumentedMethodsAt: aClass.
		registeredMethods remove: selector.
		registeredMethods ifEmpty: [self instrumentedMethods removeKey: aClass].
	].! !

Object subclass: #SyOperation
	instanceVariableNames: 'selector receiverUUID arguments'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSync-Shared'!

!SyOperation class methodsFor: 'instance creation' stamp: 'SR 5/17/2010 20:14:46.955'!
receiver: aUUID selector: aSelector arguments: anArray

	^ self new
		receiverUUID: aUUID;
		selector: aSelector;
		arguments: anArray;
		yourself
		! !

!SyOperation class methodsFor: 'instance creation' stamp: 'SR 5/20/2010 18:25:43.164'!
shouldBeReplicated: aSelector

	^ ({#=.} includes: aSelector) not! !

!SyOperation methodsFor: 'testing' stamp: 'mt 5/30/2010 22:05:15.251'!
= other

	^ self receiverUUID = other receiverUUID
		and: [self selector = other selector]
		and: [self arguments = other arguments]! !

!SyOperation methodsFor: 'accessing' stamp: 'SR 5/17/2010 19:38:33.632'!
arguments
	^ arguments! !

!SyOperation methodsFor: 'accessing' stamp: 'SR 5/17/2010 19:38:33.644'!
arguments: anObject
	arguments := anObject! !

!SyOperation methodsFor: 'accessing' stamp: 'SR 5/17/2010 19:38:40.664'!
receiverUUID
	^ receiverUUID! !

!SyOperation methodsFor: 'accessing' stamp: 'SR 5/17/2010 19:38:40.676'!
receiverUUID: anObject
	receiverUUID := anObject! !

!SyOperation methodsFor: 'accessing' stamp: 'SR 5/17/2010 19:38:48.177'!
selector
	^ selector! !

!SyOperation methodsFor: 'accessing' stamp: 'SR 5/17/2010 19:38:48.189'!
selector: anObject
	selector := anObject! !

Object subclass: #SyProtocolProcessor
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSync-Shared'!

!SyProtocolProcessor methodsFor: 'serialisation' stamp: 'mt 5/30/2010 18:11:24.099'!
deserialize: aString
	"Convert the given string into a real object."
	
	self subclassResponsibility.! !

!SyProtocolProcessor methodsFor: 'receiving' stamp: 'mt 5/30/2010 21:39:10.819'!
processDataFrom: aStream senderID: aString
	"Hint: Expect stream API from SocketStream. Other Streams should work as well. Use the given ID to enable better content handling, e.g. for servers."
	
	self subclassResponsibility.! !

!SyProtocolProcessor methodsFor: 'sending' stamp: 'SR 5/20/2010 18:27:17.111'!
sendCommandBlocking: aCommandString on: aStream
	"Sends command to server and returns its answer. Responsible for command-response-scheme."
	
	self subclassResponsibility! !

!SyProtocolProcessor methodsFor: 'sending' stamp: 'SR 5/20/2010 18:28:03.24'!
sendOperationNonBlocking: anOperation to: aStream
	"Sends an Operation to the server, but does so asynchronously. Therefore all implementions should return fast."

	self subclassResponsibility! !

!SyProtocolProcessor methodsFor: 'serialisation' stamp: 'mt 5/30/2010 18:10:53.106'!
serialize: anObject
	"Convert the given object into a string that can be written onto a stream."
	
	self subclassResponsibility.! !

SyProtocolProcessor subclass: #SySimpleProtocolProcessor
	instanceVariableNames: 'outgoingQueue outgoingQueueWorker currentCommandResultCache currentCommandResultSemaphore incomingQueue incomingCommandQueue nextCommandID'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSync-Shared'!

!SySimpleProtocolProcessor commentStamp: 'mt 5/31/2010 09:15:17.382' prior: 0!
Wire Protocol
---

1) All data is serialized or deserialized according to #serialize: and #deserialize:.

2) In a first version, JSON is used to serialize messages.

3) Messages are separated on the wire using a unique #messageEndToken.

4) Each message is dictionary with the following content:
	#channel -> aNumber
	#data -> aString
	
5) There is a #channel for commands, one for results of commands, and one for operations/updates.

6) For each command an increasing ID is sent along to verify the result on the command result channel:
	#id -> aNumber
	#command -> aString
	
7) The result of a command is as follows:
	#id -> aNumber
	#result -> aString
	
8) Update messages have to be deserialized in the #data field.!

!SySimpleProtocolProcessor class methodsFor: 'channel-numbers' stamp: 'SR 5/25/2010 18:45:29.7'!
commandChannelNumber

	^ 100! !

!SySimpleProtocolProcessor class methodsFor: 'channel-numbers' stamp: 'mt 5/31/2010 08:51:03.396'!
commandResultChannelNumber

	^ 150! !

!SySimpleProtocolProcessor class methodsFor: 'channel-numbers' stamp: 'SR 5/25/2010 18:45:25.416'!
updateChannelNumber

	^ 200! !

!SySimpleProtocolProcessor methodsFor: 'serialisation' stamp: 'mt 5/30/2010 18:21:01.153'!
deserialize: aStringOrStream

	^ Json readFrom: aStringOrStream readStream! !

!SySimpleProtocolProcessor methodsFor: 'initialize-release' stamp: 'mt 5/31/2010 08:43:39.741'!
initialize

	super initialize.
	outgoingQueue := SharedQueue new.
	incomingQueue := SharedQueue new.
	
	currentCommandResultSemaphore := Semaphore new. "To wait for command results."
	incomingCommandQueue := SharedQueue new. "To schedule incoming commands."
	nextCommandID := 0.! !

!SySimpleProtocolProcessor methodsFor: 'sending' stamp: 'SR 5/25/2010 18:56:02.8'!
killOutgoingQueueWorker
	"Only use in client mode."

	((outgoingQueueWorker isNil) or: [outgoingQueueWorker isTerminated]) ifFalse: [ outgoingQueueWorker terminate ].! !

!SySimpleProtocolProcessor methodsFor: 'commands' stamp: 'mt 5/31/2010 08:30:32.491'!
list: aStream
	"Perform the 'list' operation blocking."

	^ (self
		sendCommandBlocking: 'list'
		on: aStream) collect: [ :data | self pvtCreateRegisteredObject: data ]! !

!SySimpleProtocolProcessor methodsFor: 'commands' stamp: 'mt 5/31/2010 09:03:35.163'!
list: commandID result: registeredObjects on: aStream
	"Answer non-blocking the result of the 'list' operation."

	| objectDicts |
	objectDicts := registeredObjects collect: [ :regObject | self pvtCreateObjectDictionary: regObject ].
	^ self
		sendCommandResult: commandID
		data: (self serialize: objectDicts)
		on: aStream.! !

!SySimpleProtocolProcessor methodsFor: 'accessing' stamp: 'mt 5/30/2010 18:59:54.864'!
messageEndToken
	"Return the token that will be transferred after the end of each message to allow the recipient of the message to recognize it fully. No message should contain this token."
	
	^ String crlf! !

!SySimpleProtocolProcessor methodsFor: 'receiving' stamp: 'mt 5/31/2010 08:19:52.723'!
nextCommand
	"Retrieve the next pending command from the incoming command queue."
	
	^ incomingCommandQueue next! !

!SySimpleProtocolProcessor methodsFor: 'receiving' stamp: 'mt 5/30/2010 21:45:15.615'!
nextUpdate
	"Retrieve the next pending operation from the incoming update queue."
	
	^ incomingQueue next! !

!SySimpleProtocolProcessor methodsFor: 'receiving' stamp: 'mt 5/31/2010 09:00:24.319'!
processDataFrom: aStream senderID: aString
	"Depending on the channel, process the data"
	
	| message |
	message := self deserialize: (aStream upToAll: self messageEndToken).

	((message at: #channel) = self class updateChannelNumber) ifTrue: [
		^ self
			pvtProcessUpdate: (self deserialize: (message at: #data))
			senderID: aString
	].

	((message at: #channel) = self class commandChannelNumber) ifTrue: [
		^ self
			pvtProcessCommand: (self deserialize: (message at: #data))
			senderID: aString. 
	].
			
	((message at: #channel) = self class commandResultChannelNumber) ifTrue: [
		^ self pvtProcessCommandResult: (self deserialize: (message at: #data)).
	].
			
! !

!SySimpleProtocolProcessor methodsFor: 'sending' stamp: 'mt 5/30/2010 21:19:56.496'!
pvtCheckOutgoingQueueWorker
	"Only use in client mode."

	((outgoingQueueWorker isNil) or: [outgoingQueueWorker isTerminated]) ifTrue: [
		outgoingQueueWorker := [ 
			[ outgoingQueue isEmpty] whileFalse: [ | opArray operationDict |
				opArray := outgoingQueue next.
				self
					sendOperationBlocking: opArray first
					to: opArray second.
			].
		] fork.
	].! !

!SySimpleProtocolProcessor methodsFor: 'serialisation' stamp: 'SR 5/20/2010 18:11:58.135'!
pvtCreateObjectDictionary: anRegisteredObject

	^ Dictionary new
		at: 'type' put: 'object';
		at: 'uuid' put: (anRegisteredObject uuid);
		at: 'class' put: (anRegisteredObject client className);
		at: 'data' put: (anRegisteredObject client instanceVariableValues);
		yourself.! !

!SySimpleProtocolProcessor methodsFor: 'serialisation' stamp: 'SR 5/25/2010 18:58:13.463'!
pvtCreateOperation: aDictionary

	^ SyOperation new
		receiverUUID: (aDictionary at: 'uuid');
		selector: ((aDictionary at: 'selector') asSymbol);
		arguments: (aDictionary at: 'arguments');
		yourself.	! !

!SySimpleProtocolProcessor methodsFor: 'serialisation' stamp: 'SR 5/20/2010 18:13:26.797'!
pvtCreateOperationDictionary: aSyOperation

	^ Dictionary new
		at: 'type' put: 'operation';
		at: 'uuid' put: (aSyOperation receiverUUID);
		at: 'selector' put: (aSyOperation selector asString);
		at: 'arguments' put: (aSyOperation arguments);
		yourself.
	! !

!SySimpleProtocolProcessor methodsFor: 'serialisation' stamp: 'SR 5/25/2010 17:45:06.366'!
pvtCreateRegisteredObject: aDictionary

	| uuid typeName variableData newObject |
	((aDictionary at: 'type') = 'object') ifTrue: [
		uuid := aDictionary at: 'uuid'.
		typeName := aDictionary at: 'class'.
		variableData := aDictionary at: 'data'.
	
		newObject := (Smalltalk at: (typeName asSymbol)) new.
		variableData withIndexDo: [:value :index | newObject instVarAt: index put: value].
	
		^  SyRegisteredObject new
			client: newObject;
			uuid: uuid;
			yourself.
	].

	^ nil! !

!SySimpleProtocolProcessor methodsFor: 'serialisation' stamp: 'SR 5/25/2010 17:41:51.915'!
pvtCreateRegisteredObjectDictionary: anRegisteredObject

	^ Dictionary new
		at: 'type' put: 'object';
		at: 'uuid' put: (anRegisteredObject uuid);
		at: 'class' put: (anRegisteredObject client className);
		at: 'data' put: (anRegisteredObject client instanceVariableValues);
		yourself.! !

!SySimpleProtocolProcessor methodsFor: 'receiving' stamp: 'mt 5/31/2010 12:20:45.318'!
pvtProcessCommand: aCommandDict senderID: aString
	"Support commands."
	
	"Schedule incoming command to be processed by client or server application."
	incomingCommandQueue nextPut: {
		aCommandDict at: #id.
		aCommandDict at: #command.
		aString}.
		
	^ true! !

!SySimpleProtocolProcessor methodsFor: 'receiving' stamp: 'mt 5/31/2010 09:01:39.764'!
pvtProcessCommandResult: aCommandResultDict
	"Save the command result and signal."
	
	(aCommandResultDict at: #id) = nextCommandID ifTrue: [
		currentCommandResultCache := aCommandResultDict at: #result.
		nextCommandID := nextCommandID + 1.
		currentCommandResultSemaphore signal.
	].
	
	"Never close connection"
	^ true! !

!SySimpleProtocolProcessor methodsFor: 'receiving' stamp: 'mt 5/30/2010 21:47:29.435'!
pvtProcessUpdate: anOperationDict senderID: aString
	"Support updates"
	
	"Schedule updates to be processed bei another worker thread from the application."
	incomingQueue nextPut: {self pvtCreateOperation: anOperationDict. aString}.
	
	"Never close connection"
	^ true
! !

!SySimpleProtocolProcessor methodsFor: 'sending' stamp: 'mt 5/30/2010 20:51:52.394'!
send: aString in: aChannelNumber on: aStream

	| message |
	message := self serialize: (Dictionary newFrom: {
		#channel -> aChannelNumber.
		#data -> aString}).
		
	aStream nextPutAll: message, self messageEndToken.
	! !

!SySimpleProtocolProcessor methodsFor: 'sending' stamp: 'mt 5/31/2010 09:11:02.991'!
sendCommandBlocking: aCommandString on: aStream
	"Sends a command and returns its answer. Responsible for command-response-scheme."

	| data result |
	data := self serialize: (Dictionary newFrom: {
		#id -> nextCommandID.
		#command -> aCommandString}).
		
	self send: data in: self class commandChannelNumber on: aStream.
	currentCommandResultSemaphore wait.
	
	result := currentCommandResultCache.
	currentCommandResultCache := nil.
	^ self deserialize: result
! !

!SySimpleProtocolProcessor methodsFor: 'sending' stamp: 'mt 5/31/2010 08:53:48.466'!
sendCommandResult: commandID data: resultData on: aStream
	"Sends command result repeating the given ID so that the sender of the command can map the result correctly."

	| data |
	data := self serialize: (Dictionary newFrom: {
		#id -> commandID.
		#result -> resultData}).
		
	self send: data in: self class commandResultChannelNumber on: aStream.
! !

!SySimpleProtocolProcessor methodsFor: 'sending' stamp: 'mt 5/30/2010 21:20:04.234'!
sendOperationBlocking: anOperation to: aStream
	"Only use in client mode."

	self
		send: (self serialize: (self pvtCreateOperationDictionary: anOperation))
		in: self class updateChannelNumber
		on: aStream.! !

!SySimpleProtocolProcessor methodsFor: 'sending' stamp: 'SR 5/25/2010 18:56:14.655'!
sendOperationNonBlocking: anOperation to: aStream
	"Only use in client mode."

	outgoingQueue nextPut: {anOperation. aStream.}.
	self pvtCheckOutgoingQueueWorker.
! !

!SySimpleProtocolProcessor methodsFor: 'serialisation' stamp: 'mt 5/30/2010 18:14:39.363'!
serialize: anObject

	^ Json render: anObject! !

Object subclass: #SyRegisteredObject
	instanceVariableNames: 'uuid client operations'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSync-Shared'!

!SyRegisteredObject methodsFor: 'accessing' stamp: 'SR 5/17/2010 20:02:18.355'!
client
	^ client! !

!SyRegisteredObject methodsFor: 'accessing' stamp: 'SR 5/17/2010 20:02:18.366'!
client: anObject
	client := anObject! !

!SyRegisteredObject methodsFor: 'initialize-release' stamp: 'SR 5/17/2010 20:02:07.393'!
initialize

	super initialize.
	operations := OrderedCollection new.! !

!SyRegisteredObject methodsFor: 'accessing' stamp: 'SR 5/17/2010 20:02:34.071'!
operations
	^ operations! !

!SyRegisteredObject methodsFor: 'accessing' stamp: 'SR 5/17/2010 20:02:34.083'!
operations: anObject
	operations := anObject! !

!SyRegisteredObject methodsFor: 'accessing' stamp: 'SR 5/17/2010 20:02:42.252'!
uuid
	^ uuid! !

!SyRegisteredObject methodsFor: 'accessing' stamp: 'SR 5/17/2010 20:02:42.265'!
uuid: anObject
	uuid := anObject! !

Object subclass: #SySimpleClient
	instanceVariableNames: 'socket instrumentor objects protocolProcessor connectionProcess'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSync-Client'!

!SySimpleClient methodsFor: 'connection-handling' stamp: 'SR 5/25/2010 18:39:13.283'!
connectToHostNamed: aHost port: aPort

	socket := SyTcpSocket openConnectionToHostNamed: aHost port: aPort.
	self
		startConnectionThread;
		pvtUpdateRepository.! !

!SySimpleClient methodsFor: 'connection-handling' stamp: 'SR 5/25/2010 18:55:11.657'!
disconnect

	socket ifNil: [^ self].
	
	"Kill connection"
	connectionProcess terminate.
	protocolProcessor killOutgoingQueueWorker.
	socket close.
	
	"Clear method wrapper"
	objects := OrderedCollection new.
	instrumentor uninstrumentAllAndReset.! !

!SySimpleClient methodsFor: 'initialize-release' stamp: 'mt 5/31/2010 09:12:10.784'!
initialize

	super initialize.
	
	objects := OrderedCollection new.
	protocolProcessor := SySimpleProtocolProcessor new.
	instrumentor := SyClassInstrumentor new processor: self.! !

!SySimpleClient methodsFor: 'connection-handling' stamp: 'SR 5/15/2010 14:50:21.163'!
isConnected

	socket ifNil: [ ^ false ].
	^ socket isConnected! !

!SySimpleClient methodsFor: 'repository' stamp: 'SR 5/20/2010 17:37:33.971'!
metaRepository

	^ objects! !

!SySimpleClient methodsFor: 'method wrappers' stamp: 'SR 5/20/2010 17:22:19.095'!
process: aSelector on: anObject with: anArray

	| registeredObject operation |
	registeredObject := objects detect: [ :regObject | regObject client == anObject ] ifNone: [^ self].
	operation := SyOperation receiver: (registeredObject uuid) selector: aSelector arguments: anArray.
	
	registeredObject operations add: operation.
	protocolProcessor sendOperationNonBlocking: operation to: socket.! !

!SySimpleClient methodsFor: 'repository' stamp: 'SR 5/25/2010 17:46:03.764'!
pvtRegister: anRegisteredObject

	(objects contains: [ :o | o == anRegisteredObject]) ifTrue: [ Exception signal: 'Object already registered' ].
	
	objects add: anRegisteredObject.
	
	"Wrap objects class if not yet wrapped"
	instrumentor instrumentClass: (anRegisteredObject client class).! !

!SySimpleClient methodsFor: 'repository' stamp: 'SR 5/17/2010 21:18:18.279'!
pvtUnregister: anObject

	objects removeAllSuchThat: [ :regObject | regObject client == anObject ].
	(objects contains: [ :o | o client class == anObject class]) ifFalse:	[
		instrumentor uninstrumentClass: (anObject class).
	].! !

!SySimpleClient methodsFor: 'repository' stamp: 'SR 5/25/2010 17:51:41.746'!
pvtUpdateRepository
	"Calls 'list' on the server"

	(protocolProcessor list: socket) do: [ :o | self pvtRegister: o ]! !

!SySimpleClient methodsFor: 'initialize-release' stamp: 'SR 5/25/2010 17:58:36.143'!
release

	self isConnected ifTrue: [ self disconnect ].
	^ super release! !

!SySimpleClient methodsFor: 'repository' stamp: 'SR 5/20/2010 17:16:09.396'!
repository

	^ objects collect: [ :regObject | regObject client ].! !

!SySimpleClient methodsFor: 'connection-handling' stamp: 'mt 5/30/2010 21:37:35.774'!
startConnectionThread

	connectionProcess := [
		[socket isConnected] whileTrue: [
			socket waitForDataIfClosed: [ self disconnect ].
			(protocolProcessor processDataFrom: socket senderID: socket remoteID)
				ifFalse: [ self disconnect ]
		].
	] forkAt: 35.! !

Object subclass: #SySimpleServer
	instanceVariableNames: 'tcpServer objects instrumentor mainProcess'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSync-Server'!

!SySimpleServer commentStamp: 'SR 5/27/2010 12:19:26.044' prior: 0!
Extends a TCP server with some managed objects.

Idea: Maybe we should composite this with a tcp server and not inherit from that...

Example:

| server o1 o2 |
server := SySimpleServer new.
o1 := Person givenName: 'Micha' surname: 'Test'.
o2 := Person givenName: 'Christoph' surname: 'Muster'.
server
	register: o1;
	register: o2;
	start;
	inspect.!

!SySimpleServer class methodsFor: 'defaults' stamp: 'mt 5/26/2010 12:59:10.538'!
defaultPort

	^ 22701! !

!SySimpleServer methodsFor: 'initialize-release' stamp: 'mt 5/31/2010 11:06:07.423'!
initialize

	super initialize.
	
	tcpServer := SyTcpServer new.
	tcpServer protocolProcessor: SySimpleProtocolProcessor new.
	
	objects := OrderedCollection new.
	instrumentor := SyClassInstrumentor new processor: self.
	
	self startMainProcess.! !

!SySimpleServer methodsFor: 'commands' stamp: 'mt 5/31/2010 09:05:18.968'!
list: commandID sender: senderID 
	"List command: sends back all registered objects current state and id"
	
	| socket |
	socket := tcpServer socketForID: senderID.
	socket ifNil: [^ self].
		
	tcpServer protocolProcessor
		list: commandID
		result: self metaRepository
		on: socket.! !

!SySimpleServer methodsFor: 'repository' stamp: 'SR 5/20/2010 18:30:12.034'!
metaRepository

	^ objects! !

!SySimpleServer methodsFor: 'command handling' stamp: 'mt 5/31/2010 09:24:52.931'!
processIncomingCommands
	"See SySimpleProtocolProcessor>>pvtProcessCommand:senderID: for more infos."
	
	| array id cmd sender |
	array := tcpServer protocolProcessor nextCommand.
	id := array first.
	cmd := array second.
	sender := array third.
	
	cmd = 'list' ifTrue: [self list: id sender: sender].
	cmd = 'quit' ifTrue: [self quit: id sender: sender]! !

!SySimpleServer methodsFor: 'commands' stamp: 'mt 5/31/2010 09:07:08.862'!
quit: commandID sender: senderID 
	"Close the connection. No response should be expected from the sender."
	
	(tcpServer socketForID: senderID)
		ifNotNilDo: [:socket | socket close].
! !

!SySimpleServer methodsFor: 'repository' stamp: 'SR 5/25/2010 17:32:17.397'!
register: anObject

	| registeredObject |
	(self repository contains: [ :o | o == anObject]) ifTrue: [ Exception signal: 'Object already registered' ].
	registeredObject := SyRegisteredObject new
		client: anObject;
		uuid: (UUID new asString);
		yourself.
	objects add: registeredObject.
	
	"Wrap objects class if not yet wrapped"
	"instrumentor instrumentClass: (anObject class)."! !

!SySimpleServer methodsFor: 'initialize-release' stamp: 'mt 5/31/2010 11:07:00.071'!
release

	mainProcess terminate.
	self stop.
	
	super release.! !

!SySimpleServer methodsFor: 'repository' stamp: 'mt 5/26/2010 13:05:08.508'!
repository

	^ objects collect: [ :regObject | regObject client ]! !

!SySimpleServer methodsFor: 'start-stop' stamp: 'mt 5/31/2010 11:06:30.576'!
start

	tcpServer listenOn: self class defaultPort.! !

!SySimpleServer methodsFor: 'command handling' stamp: 'mt 5/31/2010 09:20:45.756'!
startMainProcess
	"This process triggers the continous work of the server."
	
	mainProcess := [
		[self processIncomingCommands] repeat.
	] fork.! !

!SySimpleServer methodsFor: 'start-stop' stamp: 'mt 5/31/2010 11:06:34.193'!
stop

	tcpServer close.! !

!SySimpleServer methodsFor: 'repository' stamp: 'SR 5/25/2010 17:40:56.509'!
unregister: anObject

	objects removeAllSuchThat: [ :regObject | regObject client == anObject ].
	
	"(objects contains: [ :o | o client class == anObject class]) ifFalse:	[
		instrumentor uninstrumentClass: (anObject class).
	]."! !

Object subclass: #SyTcpServer
	instanceVariableNames: 'listenSocket listenProcess connections connectionProcesses connectionChangesMonitor protocolProcessor'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSync-Server'!

!SyTcpServer commentStamp: 'mt 5/19/2010 12:50:32.652' prior: 0!
I am able to accept and manage incoming TCP connections.!

!SyTcpServer methodsFor: 'connection open/close' stamp: 'rkrk 5/26/2010 15:43:51.034'!
close

	"Closing listen part"
	listenProcess terminate.
		
	"Closing connection part"
	self connectionProcesses do: [:proc | proc terminate].
	self connectionProcesses removeAll.! !

!SyTcpServer methodsFor: 'accessing - private' stamp: 'SR 5/10/2010 17:28:42.275'!
connectionProcesses

	^ connectionProcesses ifNil: [connectionProcesses := SySharedList new]! !

!SyTcpServer methodsFor: 'accessing - private' stamp: 'mt 5/9/2010 16:46:22.708'!
connections

	^ connections ifNil: [connections := SySharedList new]! !

!SyTcpServer methodsFor: 'testing' stamp: 'mt 5/9/2010 16:17:23.888'!
isListening

	^ self listenSocket isWaitingForConnection! !

!SyTcpServer methodsFor: 'listening' stamp: 'rkrk 5/14/2010 13:30'!
listenOn: aPort

	self isListening ifTrue: [self error: 'Server already listening!!'].
	self listenSocket listenOn: aPort backlogSize: 4.
	self startListenThread.! !

!SyTcpServer methodsFor: 'accessing - private' stamp: 'mt 5/9/2010 15:58:25.953'!
listenSocket

	^ listenSocket ifNil: [listenSocket := Socket newTCP]! !

!SyTcpServer methodsFor: 'listening' stamp: 'mt 5/29/2010 12:32:13.073'!
listenerProcessPriority

	^ Processor lowIOPriority! !

!SyTcpServer methodsFor: 'debugging' stamp: 'rkrk 5/14/2010 17:31'!
log: msg

	Transcript cr; show: msg asString.! !

!SyTcpServer methodsFor: 'handling' stamp: 'rkrk 5/26/2010 15:41:28.56'!
newConnectionOn: socket

	| con |
	con := SyTcpSocket on: socket.
	self connections add: con.
	self startConnectionThreadFor: con.
! !

!SyTcpServer methodsFor: 'accessing' stamp: 'mt 5/9/2010 17:12:59.484'!
port

	^ self listenSocket port! !

!SyTcpServer methodsFor: 'accessing' stamp: 'mt 5/29/2010 10:32:05.82'!
protocolProcessor

	^ protocolProcessor! !

!SyTcpServer methodsFor: 'accessing' stamp: 'mt 5/26/2010 13:02:36.831'!
protocolProcessor: aProtocolProcessor

	protocolProcessor := aProtocolProcessor.! !

!SyTcpServer methodsFor: 'accessing' stamp: 'mt 5/31/2010 08:40:06.698'!
socketForID: senderID
	"Return the stream corresponding to the given ID."

	^ self connections
		detect: [:con | con remoteID = senderID]
		ifNone: []! !

!SyTcpServer methodsFor: 'handling' stamp: 'mt 5/31/2010 11:38:28.066'!
startConnectionThreadFor: socket

	| connectionProcess |
	connectionProcess := [
		[[socket isConnected] whileTrue: [
				socket waitForDataIfClosed: [Processor activeProcess terminate].
				self protocolProcessor ifNotNilDo: [:p |
					(p processDataFrom: socket senderID: socket remoteID) ifFalse: [Processor activeProcess terminate]].
		]] ensure: [
			socket close.
			self connections remove: socket ifAbsent: [].
			self log: 'Some client socket closed'; log: socket debug].
	] newProcess.
	self connectionProcesses add: connectionProcess.
	connectionProcess resume.! !

!SyTcpServer methodsFor: 'listening' stamp: 'mt 5/31/2010 08:01:17.378'!
startListenThread
	
	listenProcess := [
		[[self isListening] whileTrue: [
				(self listenSocket waitForAcceptFor: 3) ifNotNilDo: [:socket |
					self newConnectionOn: socket.
					self log: 'New client connected: ' , socket remoteAddress , ' ' , socket statusString]]
		] ensure: [
			self log: 'listener terminating, socket: ' , (listenSocket ifNotNilDo: [:s | s statusString]).
			listenSocket isValid ifTrue: [listenSocket closeAndDestroy].
			listenSocket := nil]
	] newProcess.

	listenProcess
		priority: self listenerProcessPriority;
		name: self class name, '''s listener process';
		resume.! !

TestCase subclass: #SyCommunicationModuleTest
	instanceVariableNames: 'tcpServer tcpSocket openClientSockets'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSync-Tests'!

!SyCommunicationModuleTest class methodsFor: 'helper' stamp: 'rkrk 5/14/2010 17:02'!
closeAllSockets

	Socket registry keys
		select: [:ea | ea isWaitingForConnection or: [ea isOtherEndClosed] or: [ea isConnected]]
		thenDo: [:ea | ea close].! !

!SyCommunicationModuleTest class methodsFor: 'constants' stamp: 'rkrk 5/14/2010 14:24'!
defaultPort

	^ 22701! !

!SyCommunicationModuleTest methodsFor: 'support' stamp: 'SR 5/31/2010 17:45:07.581'!
connectTCPClientToServer

	tcpSocket := SyTcpSocket
		connectToHost: '127.0.0.1'
		port: self class defaultPort.
	openClientSockets add: tcpSocket.
	
	(Delay forMilliseconds: 100) wait.
	Processor yield.
	
	^ tcpSocket.! !

!SyCommunicationModuleTest methodsFor: 'support' stamp: 'SR 5/31/2010 17:45:19.684'!
disconnectTCPClientsFromServer

	tcpSocket ifNotNil: [tcpSocket close. tcpSocket := nil].
	openClientSockets do: [:ea | ea close].
	
	(Delay forMilliseconds: 100) wait.
	Processor yield.! !

!SyCommunicationModuleTest methodsFor: 'running' stamp: 'rkrk 5/14/2010 18:17'!
setUp

	super setUp.
	openClientSockets := OrderedCollection new.
	Transcript cr; show: 'start '; show: self selector.! !

!SyCommunicationModuleTest methodsFor: 'support' stamp: 'mt 5/10/2010 11:39:41.976'!
startTcpServer

	tcpServer ifNil: [tcpServer := SyTcpServer new].
	tcpServer isListening
		ifFalse: [tcpServer listenOn: self class defaultPort].! !

!SyCommunicationModuleTest methodsFor: 'support' stamp: 'rkrk 5/26/2010 15:48:10.549'!
stopTcpServer

	tcpServer ifNotNil: [tcpServer close].! !

!SyCommunicationModuleTest methodsFor: 'running' stamp: 'rkrk 5/14/2010 18:15'!
tearDown

	super tearDown.
	Transcript cr; show: 'end '; show: self selector.
	[self
		disconnectTCPClientsFromServer;
		stopTcpServer
	] on: Error do: [:e | Transcript cr; show: 'Error in tearDown'; print: e].! !

!SyCommunicationModuleTest methodsFor: 'tests' stamp: 'rkrk 5/28/2010 00:50:34.851'!
test01TcpServerStartup

	| sut |
	sut := SyTcpServer new.
	
	self deny: sut isListening.
	
	[sut listenOn: self class defaultPort.
	self
		assert: sut isListening;
		assert: self class defaultPort equals: sut port;
		assert: sut connections isEmpty.
	] ensure: [sut close].! !

!SyCommunicationModuleTest methodsFor: 'tests' stamp: 'rkrk 5/28/2010 00:50:03.209'!
test02TcpServerShutdown
	
	self
		startTcpServer;
		assert: tcpServer isListening;
		stopTcpServer;
		deny: tcpServer isListening;
		assert: tcpServer connections isEmpty;
		assert: tcpServer connectionProcesses isEmpty;
		assert: (Socket registry keys noneSatisfy: [:socket | socket isWaitingForConnection]).! !

!SyCommunicationModuleTest methodsFor: 'tests' stamp: 'rkrk 5/28/2010 00:40:31.018'!
test03FailingTcpSocketConnection

	"try to connect to a server. This should either throw a ConnectionTimedOut error.
	Since we currently cannot control the timeout period of sockets and the default of 
	[Socket standardTimeout] = 45 is used we end the test earlier and just assume
	that the connection can't be established."
	<timeout: 3> "1s more than needed"
	| connectionFailed connectReturned connectProcess |
	connectionFailed := false.
	connectReturned := false.
	connectProcess := [
		[self connectTCPClientToServer. connectReturned := true]
			on: ConnectionTimedOut
			do: [connectionFailed := true]] fork.
	self wait: 2. "seconds"
	connectProcess terminate.
	connectionFailed ifTrue: [^self].
	connectReturned ifTrue: [^self]. "assume it works"
	self
		assert: false
		description: '#connectTCPClientToServer was successful although no server was started!!'.! !

!SyCommunicationModuleTest methodsFor: 'tests' stamp: 'rkrk 5/28/2010 00:49:28.164'!
test04TcpSocketConnection

	self
		startTcpServer;
		connectTCPClientToServer;
		assert: tcpSocket isConnected description: 'tcp socket not connected';
		assert: 1 equals: tcpServer connectionProcesses size.! !

!SyCommunicationModuleTest methodsFor: 'tests' stamp: 'rkrk 5/28/2010 00:49:47.813'!
test05TcpServerIncomingConnections

	self
		startTcpServer;
		assert: tcpServer connections isEmpty;
		connectTCPClientToServer;
		assert: tcpServer connections size = 1;
		connectTCPClientToServer;
		assert: tcpServer connections size = 2;
		disconnectTCPClientsFromServer;
		assert: tcpServer connections isEmpty.! !

!SyCommunicationModuleTest methodsFor: 'support' stamp: 'rkrk 5/14/2010 16:55'!
wait: seconds

	(Delay forSeconds: seconds) wait.! !

TestCase subclass: #SySimpleClientObjectTest
	instanceVariableNames: 'server o1 o2 sut'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSync-Tests'!

!SySimpleClientObjectTest class methodsFor: 'as yet unclassified' stamp: 'SR 5/15/2010 14:41:32.817'!
defaultPort

	^ 22701! !

!SySimpleClientObjectTest methodsFor: 'running' stamp: 'mt 5/26/2010 13:06:14.781'!
setUp

	server := SySimpleServer new.
	o1 := Person givenName: 'Micha' surname: 'Test'.
	o2 := Person givenName: 'Christoph' surname: 'Muster'.
	server
		register: o1;
		register: o2;
		start.
		
	sut := SySimpleClient new.! !

!SySimpleClientObjectTest methodsFor: 'running' stamp: 'mt 5/26/2010 13:22:17.503'!
tearDown

	sut disconnect.
	
	server
		unregister: o1;
		unregister: o2;
		stop.! !

!SySimpleClientObjectTest methodsFor: 'testing' stamp: 'SR 5/15/2010 14:52:42.972'!
test01ConnectDisconnect

	sut connectToHostNamed: '127.0.0.1' port: self class defaultPort.
	self assert: sut isConnected.
	sut disconnect.! !

!SySimpleClientObjectTest methodsFor: 'testing' stamp: 'SR 5/20/2010 17:16:09.462'!
test02GetObjects

	sut connectToHostNamed: '127.0.0.1' port: self class defaultPort.
	self assert: sut isConnected.
	
	self assert: (sut repository size = 2).
	self assert: (sut repository contains: [:o| o = o1]).
	self assert: (sut repository contains: [:o| o = o2]).
	
	
	sut disconnect.! !

!SySimpleClientObjectTest methodsFor: 'testing' stamp: 'SR 5/25/2010 17:58:18.588'!
test03UnWrapObject

	self deny: (o1 class methodDict values first isMwMethodWrapper).
	sut connectToHostNamed: '127.0.0.1' port: self class defaultPort.
	self assert: (o1 class methodDict values first isMwMethodWrapper).
	sut disconnect.
	self deny: (o1 class methodDict values first isMwMethodWrapper).! !

!SySimpleClientObjectTest methodsFor: 'testing' stamp: 'SR 5/25/2010 17:57:27.733'!
test04OperationStackTest

	| o1 |
	sut connectToHostNamed: '127.0.0.1' port: self class defaultPort.
	o1 := sut repository first.

	self assert: ((sut metaRepository detect: [:o | o client == o1 ]) operations isEmpty).
	o1 givenName: 'Test2'.
	self assert: ((sut metaRepository detect: [:o | o client == o1 ]) operations size = 1).
	self assert: ((sut metaRepository detect: [:o | o client == o1 ]) operations first selector = #givenName:).
! !

TestCase subclass: #SySimpleProtocolProcessorTest
	instanceVariableNames: 'sut o1 stream'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSync-Tests'!

!SySimpleProtocolProcessorTest methodsFor: 'support' stamp: 'mt 5/30/2010 21:10:42.257'!
clearStream

	stream := ReadWriteStream on: ''.! !

!SySimpleProtocolProcessorTest methodsFor: 'support' stamp: 'mt 5/30/2010 21:18:41.14'!
resetStream

	stream reset.! !

!SySimpleProtocolProcessorTest methodsFor: 'running' stamp: 'mt 5/30/2010 20:46:11.522'!
setUp

	super setUp.
	sut := SySimpleProtocolProcessor new.
	o1 := Dictionary newFrom: {
		#tag -> 'uuid'.
		#value -> UUID new asString}.
	self clearStream.! !

!SySimpleProtocolProcessorTest methodsFor: 'testing' stamp: 'mt 5/30/2010 20:43:53.893'!
test01Serialization

	self assert: (sut deserialize: (sut serialize: o1)) = o1.! !

!SySimpleProtocolProcessorTest methodsFor: 'testing' stamp: 'mt 5/30/2010 22:05:55.576'!
test02Sending
	"Try to send a simple message. Tests the usage of serialization and token for messages ends."

	| result |
	sut
		send: 'foobar'
		in: 0
		on: stream.
	
	result := (sut serialize: (Dictionary newFrom: {#channel -> 0. #data -> 'foobar'})), sut messageEndToken.
	
	self assert: result equals: stream contents.! !

!SySimpleProtocolProcessorTest methodsFor: 'testing' stamp: 'mt 5/30/2010 22:05:30.845'!
test03ReceivingUpdates

	| op nextUpdate |
	op := SyOperation
		receiver: UUID new asString
		selector: #foobar
		arguments: {#first. #second}.
		
	sut
		sendOperationBlocking: op
		to: stream.
	
	self resetStream.
	sut processDataFrom: stream senderID: '127.0.0.1:6000'.
	
	nextUpdate := sut nextUpdate.
	self assert: {op. '127.0.0.1:6000'} equals: nextUpdate.! !

!SySimpleProtocolProcessorTest methodsFor: 'testing' stamp: 'mt 5/31/2010 09:46:11.596'!
test04SendingReceivingCommands

	| process result nextCommand |
		
	process := [result := sut
		sendCommandBlocking: 'foobar'
		on: stream] forkAt: 60.
	
	self resetStream.
	sut processDataFrom: stream senderID: '127.0.0.1:6000'.
	
	nextCommand := sut nextCommand.
	self assert: {0. 'foobar'. '127.0.0.1:6000'} equals: nextCommand.
	
	self clearStream.
	sut 
		sendCommandResult: 0
		data: (sut serialize: 'blubb')
		on: stream.
	
	self resetStream.
	sut processDataFrom: stream senderID: '127.0.0.1:6000'.
	
	Processor yield. "Let the result variable be set."

	self
		assert: 'blubb' equals: result;
		assert: process isTerminated.! !

TestCase subclass: #SySimpleServerObjectRepoTests
	instanceVariableNames: 'sut'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSync-Tests'!

!SySimpleServerObjectRepoTests methodsFor: 'running' stamp: 'SR 5/15/2010 12:08:17.176'!
setUp

	super setUp.
	sut := SySimpleServer new.! !

!SySimpleServerObjectRepoTests methodsFor: 'testing' stamp: 'SR 5/20/2010 17:16:09.427'!
test01UnRegisterObject

	| o1 |
	o1 := Person new.
	self assert: (sut repository isEmpty).
	sut register: o1.
	self assert: (sut repository size = 1).
	sut unregister: o1.
	self assert: (sut repository isEmpty).! !

!SySimpleServerObjectRepoTests methodsFor: 'testing' stamp: 'mt 5/26/2010 12:52:45.402'!
test02DoubleRegistration

	| o1 |
	o1 := Person new.
	self assert: sut repository isEmpty.
	sut register: o1.
	self assert: sut repository size = 1.
	
	self
		should: [sut register: o1]
		raise: Exception.
	
	sut unregister: o1.
! !

TestCase subclass: #SySocketBugTest
	instanceVariableNames: 's1 s2 s3'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSync-Tests'!

!SySocketBugTest methodsFor: 'running' stamp: 'rkrk 5/29/2010 11:56:47.535'!
tearDown

	super tearDown.
	s1 closeAndDestroy.
	s2 closeAndDestroy.
	s3 closeAndDestroy.! !

!SySocketBugTest methodsFor: 'testing' stamp: 'mt 5/31/2010 12:00:17.802'!
test01AutoDisconnection

	s1 := Socket newTCP.
	s2 := Socket newTCP.
	s1 listenOn: 12345.
	s3 := s2 connectToHostNamed: 'localhost' port:  12345.
	s1 waitForConnectionFor: 5.
	s2 waitForConnectionFor: 5.
	self
		assert: s1 isConnected;
		assert: s2 isConnected;
		assert: s3 == s2.

	s2 closeAndDestroy.
	s1 forceStatusUpdate.
		
	self
		deny: s2 isConnected;
		deny: s1 isConnected.! !

!SySocketBugTest methodsFor: 'testing' stamp: 'mt 5/31/2010 12:00:23.284'!
test02AutoDisconnectionWithServer

	s1 := Socket newTCP.
	s2 := Socket newTCP.
	s1 listenOn: 12345 backlogSize: 4.
	s2 connectToHostNamed: 'localhost' port:  12345.
	s3 := s1 waitForAcceptFor: 5.
	s2 waitForConnectionFor: 5.
	
	self
		deny: s1 isConnected;
		assert: s2 isConnected;
		assert: s3 isConnected.

	s2 closeAndDestroy.
	s3 forceStatusUpdate.
		
	self
		deny: s1 isConnected;
		deny: s2 isConnected;
		deny: s3 isConnected.! !

!SySocketBugTest methodsFor: 'testing' stamp: 'mt 5/31/2010 13:37:50.642'!
test03StreamWorkaround
	"Check whether the workaround discards no data unexpectedly."

	| stream1 stream2 |
	
	s1 := Socket newTCP.
	s2 := Socket newTCP.
	s1 listenOn: 12345.
	s3 := s2 connectToHostNamed: 'localhost' port:  12345.
	s1 waitForConnectionFor: 5.
	s2 waitForConnectionFor: 5.
	
	stream1 := SyTcpSocket on: s1.
	stream2 := SyTcpSocket on: s2.
	
	stream1 nextPutAll: 'Hello!!'.
	stream2 isConnected. "This contains the workaround."
	
	self assert: 'Hello' equals: (stream2 upToAll: '!!').
! !

OrderedCollection subclass: #SySharedList
	instanceVariableNames: 'mutex'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSync-Shared'!

!SySharedList commentStamp: 'mt 5/9/2010 17:04:27.753' prior: 0!
This is meant to be a thread-safe version of an OrderedCollection. See the "list" protocol to explore selectors which are thread-safe.!

!SySharedList methodsFor: 'list' stamp: 'mt 5/9/2010 16:52:24.122'!
add: anElement

	^ self mutex critical: [super add: anElement].! !

!SySharedList methodsFor: 'list' stamp: 'mt 5/31/2010 08:37:35.378'!
detect: aBlock ifNone: aNoneBlock

	^ self mutex critical: [super detect: aBlock ifNone: aNoneBlock]! !

!SySharedList methodsFor: 'accessing - private' stamp: 'mt 5/9/2010 16:40:52.25'!
mutex

	^ mutex ifNil: [mutex := Mutex new]! !

!SySharedList methodsFor: 'list' stamp: 'mt 5/9/2010 16:53:19.735'!
remove: anElement ifAbsent: aBlock
	"#remove: should also be guarded now."
	
	^ self mutex critical: [super remove: anElement ifAbsent: aBlock].! !

!SySharedList methodsFor: 'list' stamp: 'mt 5/30/2010 19:50:56.398'!
size

	^ self mutex critical: [super size]! !
